:- use_module(library(lists)).
:- use_module(benchmarks).
:- use_module(abstract).
:- use_module(linear_fixpoint).
:- use_module(utilities).

analyser :-
	format("file      [differ, msort, qsort, queens, sort]: ", []), ttyflush,
	read(File),
	format("trace     [log, off, step]: ", []),
	read(Trace),
	statistics(runtime, _),
	abstract_program(File, SCCs),
	concat(['../', File, '/', File, '-lfp.clpr'], Linear_LFP_File),
	format("~n{lfp with inequalities... ", []),
	linear_lfp_program(SCCs, Trace),
	linear_lfp_pretty_print(Linear_LFP_File),
	statistics(runtime, [_, LFP_Time]),
	format("~wms}", [LFP_Time]).
