:- use_module(library(terms)).
:- use_module(library(clpq)).
:- use_module(library(lists)).
:- use_module(library(random)).

%?- { 2*X+Y =< 16, X+2*Y =< 11,
%            X+3*Y =< 15, Z = 30*X+50*Y
%          }, maximize(Z).
%
%X = 7,
%Y = 2,
%Z = 310
%

%main(Alphas, Beta) :-
%	Scalars = [
%		scalar([F-1],=<,0),
%		scalar([F- -1],=<,0),
%		scalar([M-1,B- -1],=<,4),
%		scalar([O- -1,A-1],=<,4),
%		scalar([M- -2,B-2,O- -1,A-1],=<,0),
%		scalar([M- -1,B-1],=<,0),
%		scalar([A- -1],=<,-4),
%		scalar([A- -2,B- -4,P-2,N-4,J-2,I- -9],=<,-14),
%		scalar([A- -1,B- -2,P-1,N-2,J-1],=<,2),
%		scalar([A- -2,B- -4,P-2,N-4,J- -7],=<,-14),
%		scalar([A- -1,B- -2,P-1,N-2,J-1,H- -9],=<,-7),
%		scalar([A- -2,P-2,J-2,I- -13],=<,-14),
%		scalar([A- -1,P-1,J-1],=<,6),
%		scalar([A- -2,P-2,J- -11],=<,-14),
%		scalar([B-2,N- -2,I- -3,H- -2],=<,0),
%		scalar([A- -2,B-4,P-2,N- -4,J-2,I- -15,H- -4],=<,-14),
%		scalar([B-2,N- -2,J- -3,H- -2],=<,0),
%		scalar([A- -2,B-4,P-2,N- -4,J- -13,H- -4],=<,-14),
%		scalar([B-1,N- -1,H- -1],=<,3),
%		scalar([A- -1,B-2,P-1,N- -2,J-1,H- -2],=<,8),
%		scalar([B-1,N- -1,H- -4],=<,0),
%		scalar([A- -1,B-2,P-1,N- -2,J-1,H- -17],=<,-7),
%		scalar([A- -1,B- -2,N-2,J-1,H- -5],=<,-7),
%		scalar([A- -11,B- -12,N-12,J-11,H- -75],=<,-77),
%		scalar([A- -20,B-18,P-9,N- -18,J-20,H- -252],=<,-140),
%		scalar([A- -2,P- -3,J-2,H- -18],=<,-14),
%		scalar([A- -2,J- -7],=<,-14),
%		scalar([A- -1,J-1],=<,2),
%		scalar([A- -2,J-2,I- -9],=<,-14),
%		scalar([A- -2,B- -4,N-4,J-2,I- -5],=<,-14),
%		scalar([A- -1,B- -2,N-2,J-1],=<,-2),
%		scalar([A- -2,B- -4,N-4,J- -3],=<,-14),
%		scalar([B- -1,N-1],=<,0),
%		scalar([L- -1,K- 1,G- 1,D- 1,C- 1],=<,-7),
%		scalar([L-1,K- -1,G- -1,D- -1,C- -1],=<,7),
%		scalar([C- -1],=<,0),
%		scalar([D- -1],=<,0),
%		scalar([E- -1],=<,0),
%		scalar([G- -1],=<,0),
%		scalar([I- -1],=<,0),
%		scalar([J- -1],=<,0),
%		scalar([K- -1],=<,0),
%		scalar([N- -1],=<,0),
%	scalar([P- -1],=<,0)],

main(Alphas, Beta) :-
	Scalars = [
		scalar([X1- 12, X2- 1, X3- -3, X4- 1],=<,1),
		scalar([X1- -36, X2- -2, X3- 18, X4- -11],=<,-2),
		scalar([X1- -18, X2- -1, X3- 9, X4- -7],=<,-1),
		scalar([X1- 45, X2- 4, X3- -18, X4- 13],=<,4),
		scalar([X1- -1],=<,0),
		scalar([X2- -1],=<,0)],
	term_variables(Scalars, Vars),
	lambdas_positive(Scalars, Lambdas),
	lambdas_sum(Lambdas, Sum),
	{Sum = 1},
	lambdas_constant(Scalars, Lambdas, Constant),
	{Beta = Constant},
	lambdas_variables(Vars, Scalars, Lambdas, Alphas),
	Alphas = [Alpha1, Alpha2, _Alpha3, _Alpha4],
%	Lambdas = [Lambda1, Lambda2, Lambda3, Lambda4, Lambda5, Lambda6],
	{Alpha1 = 0, Alpha2 = 0},
	lambdas_cost(Lambdas, Cost),
	format("~nCost = ~w", [Cost]),
	maximize(Cost).

lambdas_positive([], []).
lambdas_positive([scalar(_, =<, _) | Scalars], [Lambda | Lambdas]) :-
	{0 =< Lambda},
	lambdas_positive(Scalars, Lambdas).

lambdas_sum([], 0).
lambdas_sum([Lambda | Lambdas], Lambda+Expr) :-
	lambdas_sum(Lambdas, Expr).

lambdas_constant([], [], 0).
lambdas_constant([scalar(_, _, Value) | Scalars], [Lambda | Lambdas], Expr) :-
	(Value == 0 ->
		Expr = Rest_Expr;
		Expr = Lambda*Value + Rest_Expr),
	lambdas_constant(Scalars, Lambdas, Rest_Expr).

lambdas_variables([], _, _, []).
lambdas_variables([Var | Vars], Scalars, Lambdas, [Alpha | Alphas]) :-
	lambdas_variable(Scalars, Lambdas, Var, Sum),
	{Alpha = Sum},
	lambdas_variables(Vars, Scalars, Lambdas, Alphas).

lambdas_variable([], [], _, 0).
lambdas_variable([scalar(Sum, _, _) | Scalars], [Lambda | Lambdas], Var, Expr) :-
	(retrieve_coeff(Sum, Var, Coeff) ->
		Expr = Coeff*Lambda + Rest_Expr;
		Expr = Rest_Expr),
	lambdas_variable(Scalars, Lambdas, Var, Rest_Expr).

lambdas_cost([], 0).
lambdas_cost([Lambda | Lambdas], (Number*Lambda)+Expr) :-
	random(-16, 16, Number),
	lambdas_cost(Lambdas, Expr).

retrieve_coeff([X-Coeff | _], EqX, EqCoeff) :-
        X == EqX,
        !,
        EqCoeff = Coeff.
retrieve_coeff([_ | Sum], EqX, EqCoeff) :-
        retrieve_coeff(Sum, EqX, EqCoeff).
