:- module(utilities, [concat/2, my_memberchk/2, my_not_memberchk/2, union/3]).
:- use_module(library(lists)).

concat(Names, TotalName) :-
	concat(Names, [], TotalName).

concat([], StrAcc, TotalName) :-
	name(TotalName, StrAcc).
concat([Name | Names], StrAcc, TotalName) :-
	name(Name, StrName),
	append(StrAcc, StrName, NewStrAcc),
	concat(Names, NewStrAcc, TotalName).

my_memberchk(List, Element) :-
	\+ my_not_memberchk(List, Element).

my_not_memberchk([], _).
my_not_memberchk([Arg | Args], Var) :-
	Arg \== Var,
	my_not_memberchk(Args, Var).

union([], Ys, Ys).
union([X | Xs], Ys, Union) :-
	my_not_memberchk(Ys, X) ->
		union(Xs, [X | Ys], Union);
		union(Xs, Ys, Union).

